---
title: Create a namespace
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[KV](https://developers.cloudflare.com/api/go/resources/kv)

[Namespaces](https://developers.cloudflare.com/api/go/resources/kv/subresources/namespaces)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Create a namespace

client.KV.Namespaces.New(ctx, params) (\*[Namespace](<https://developers.cloudflare.com/api/go/resources/kv#(resource)%20kv.namespaces%20%3E%20(model)%20namespace%20%3E%20(schema)>), error)

POST/accounts/{account\_id}/storage/kv/namespaces

Creates a Workers KV namespace in the specified account with the given title. Returns `400` if the account already owns a namespace with that title; an existing namespace must be explicitly deleted before it can be replaced. An optional jurisdiction restricts where data is durably stored and can only be set at creation time.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Workers KV Storage Write`

##### ParametersExpand Collapse

<details>

<summary>

params NamespaceNewParams

</summary>

AccountID param.Field\[string]

Path param: ID of the Cloudflare account that owns the Workers KV namespaces.

maxLength32

<a href="#(resource)%20kv.namespaces%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

Title param.Field\[string]

Body param: Human-readable string name for a Workers KV namespace.

maxLength512

<a href="#(resource)%20kv.namespaces%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20title">Link to this property</a>

<details>

<summary>

Jurisdiction param.Field\[<a href="https://developers.cloudflare.com/api/go/resources/kv/subresources/namespaces/methods/create#(resource)%20kv.namespaces%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20jurisdiction%20%3E%20(schema)">NamespaceNewParamsJurisdiction</a>]Optional

Body param: Specify the jurisdiction to restrict the KV namespace to durably store data within. Can only be set at namespace creation time.

</summary>

const NamespaceNewParamsJurisdictionEu <a href="https://developers.cloudflare.com/api/go/resources/kv/subresources/namespaces/methods/create#(resource)%20kv.namespaces%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20jurisdiction%20%3E%20(schema)">NamespaceNewParamsJurisdiction</a> = "eu"

<a href="#(resource)%20kv.namespaces%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20jurisdiction%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

const NamespaceNewParamsJurisdictionFedramp <a href="https://developers.cloudflare.com/api/go/resources/kv/subresources/namespaces/methods/create#(resource)%20kv.namespaces%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20jurisdiction%20%3E%20(schema)">NamespaceNewParamsJurisdiction</a> = "fedramp"

<a href="#(resource)%20kv.namespaces%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20jurisdiction%20%3E%20(schema)%20%3E%20(member)%201">Link to this property</a>

const NamespaceNewParamsJurisdictionUs <a href="https://developers.cloudflare.com/api/go/resources/kv/subresources/namespaces/methods/create#(resource)%20kv.namespaces%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20jurisdiction%20%3E%20(schema)">NamespaceNewParamsJurisdiction</a> = "us"

<a href="#(resource)%20kv.namespaces%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20jurisdiction%20%3E%20(schema)%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20kv.namespaces%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20jurisdiction">Link to this property</a>

<details>

<summary>

Mode param.Field\[<a href="https://developers.cloudflare.com/api/go/resources/kv/subresources/namespaces/methods/create#(resource)%20kv.namespaces%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20mode%20%3E%20(schema)">NamespaceNewParamsMode</a>]Optional

Body param: The mode of the Workers KV namespace. Specify <code>instant</code> when creating a namespace to create a KV Instant namespace. Omit this field when creating a namespace to create a classic namespace. Currently, <code>instant</code> is the only supported explicit value.

</summary>

const NamespaceNewParamsModeInstant <a href="https://developers.cloudflare.com/api/go/resources/kv/subresources/namespaces/methods/create#(resource)%20kv.namespaces%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20mode%20%3E%20(schema)">NamespaceNewParamsMode</a> = "instant"

<a href="#(resource)%20kv.namespaces%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20mode%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

</details>

<a href="#(resource)%20kv.namespaces%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20mode">Link to this property</a>

</details>

[Link to this property](<#(resource)%20kv.namespaces%20%3E%20(method)%20create%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type Namespace struct{…}

</summary>

ID string

ID of the Workers KV namespace.

maxLength32

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20namespace%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

Title string

Human-readable string name for a Workers KV namespace.

maxLength512

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20namespace%20%3E%20(schema)%20%3E%20(property)%20title">Link to this property</a>

<details>

<summary>

Jurisdiction NamespaceJurisdictionOptional

Specify the jurisdiction to restrict the KV namespace to durably store data within. Can only be set at namespace creation time.

</summary>

One of the following:

const NamespaceJurisdictionEu NamespaceJurisdiction = "eu"

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20namespace%20%3E%20(schema)%20%3E%20(property)%20jurisdiction%20%3E%20(member)%200">Link to this property</a>

const NamespaceJurisdictionFedramp NamespaceJurisdiction = "fedramp"

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20namespace%20%3E%20(schema)%20%3E%20(property)%20jurisdiction%20%3E%20(member)%201">Link to this property</a>

const NamespaceJurisdictionUs NamespaceJurisdiction = "us"

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20namespace%20%3E%20(schema)%20%3E%20(property)%20jurisdiction%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20namespace%20%3E%20(schema)%20%3E%20(property)%20jurisdiction">Link to this property</a>

Mode NamespaceModeOptional

The mode of the Workers KV namespace. Specify <code>instant</code> when creating a namespace to create a KV Instant namespace. Omit this field when creating a namespace to create a classic namespace. Currently, <code>instant</code> is the only supported explicit value.

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20namespace%20%3E%20(schema)%20%3E%20(property)%20mode">Link to this property</a>

SupportsURLEncoding boolOptional

True if keys written on the URL will be URL-decoded before storing. For example, if set to “true”, a key written on the URL as “%3F” will be stored as ”?”.

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20namespace%20%3E%20(schema)%20%3E%20(property)%20supports_url_encoding">Link to this property</a>

</details>

[Link to this property](<#(resource)%20kv.namespaces%20%3E%20(model)%20namespace%20%3E%20(schema)>)

### Create a namespace

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/kv"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  namespace, err := client.KV.Namespaces.New(context.TODO(), kv.NamespaceNewParams{
    AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
    Title: cloudflare.F("My Own Namespace"),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", namespace.ID)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "id": "0f2ac74b498b48028cb68387c421e279",
    "title": "My Own Namespace",
    "jurisdiction": "eu",
    "mode": "instant",
    "supports_url_encoding": true
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "id": "0f2ac74b498b48028cb68387c421e279",
    "title": "My Own Namespace",
    "jurisdiction": "eu",
    "mode": "instant",
    "supports_url_encoding": true
  }
}
```